# DragonswapV2Factory

Deploys DragonswapV2 pools and manages ownership and control over pool protocol fees

### Functions[​](https://docs.uniswap.org/contracts/v3/reference/core/UniswapV3Factory#functions) <a href="#functions" id="functions"></a>

#### createPool[​](https://docs.uniswap.org/contracts/v3/reference/core/UniswapV3Factory#createpool) <a href="#createpool" id="createpool"></a>

```solidity
  function createPool(
    address tokenA,
    address tokenB,
    uint24 fee
  ) external returns (address pool)
```

Creates a pool for the given two tokens and fee

tokenA and tokenB may be passed in either order: token0/token1 or token1/token0. tickSpacing is retrieved from the fee. The call will revert if the pool already exists, the fee is invalid, or the token arguments are invalid.

**Parameters:**[**​**](https://docs.uniswap.org/contracts/v3/reference/core/UniswapV3Factory#parameters)

| Name     | Type    | Description                                     |
| -------- | ------- | ----------------------------------------------- |
| `tokenA` | address | One of the two tokens in the desired pool       |
| `tokenB` | address | The other of the two tokens in the desired pool |
| `fee`    | uint24  | The desired fee for the pool                    |

**Return Values:**[**​**](https://docs.uniswap.org/contracts/v3/reference/core/UniswapV3Factory#return-values)

| Name   | Type    | Description                           |
| ------ | ------- | ------------------------------------- |
| `pool` | address | The address of the newly created pool |

#### setOwner[​](https://docs.uniswap.org/contracts/v3/reference/core/UniswapV3Factory#setowner) <a href="#setowner" id="setowner"></a>

```solidity
  function setOwner(
    address _owner
  ) external
```

Updates the owner of the factory

Must be called by the current owner

**Parameters:**[**​**](https://docs.uniswap.org/contracts/v3/reference/core/UniswapV3Factory#parameters-1)

| Name     | Type    | Description                  |
| -------- | ------- | ---------------------------- |
| `_owner` | address | The new owner of the factory |

#### enableFeeAmount[​](https://docs.uniswap.org/contracts/v3/reference/core/UniswapV3Factory#enablefeeamount) <a href="#enablefeeamount" id="enablefeeamount"></a>

```solidity
  function enableFeeAmount(
    uint24 fee,
    int24 tickSpacing
  ) public
```

Enables a fee amount with the given tickSpacing

Fee amounts may never be removed once enabled

**Parameters:**[**​**](https://docs.uniswap.org/contracts/v3/reference/core/UniswapV3Factory#parameters-2)

| Name          | Type   | Description                                                                              |
| ------------- | ------ | ---------------------------------------------------------------------------------------- |
| `fee`         | uint24 | The fee amount to enable, denominated in hundredths of a bip (i.e. 1e-6)                 |
| `tickSpacing` | int24  | The spacing between ticks to be enforced for all pools created with the given fee amount |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.dragonswap.app/dragonswap/resources/developer-resources/smart-contracts/dragonswapv2/core/dragonswapv2factory.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
